import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.JOptionPane;

/**
 * Write a description of class Rumput here.
 * 
 * @author Budi Susanto
 * @version April 27, 2011
 */
public class Rumput  extends World
{
    private Batu batu1;
    private Batu batu2;
    private long time;
    private java.text.Format formatter;
    private SeranggaCoklat[] coklat;
    private SeranggaKuning[] kuning;
    
    private final int MAX_SERANGGAMERAH = 5;
    
    public static LabelTeks label = new LabelTeks();
    private LabelTeks labelTime;
    public static int skor = 0;
    
    private static GreenfootSound snd1;
    private static GreenfootSound snd2;

    
    /**
     * Constructor for objects of class Rumput.
     * 
     */
    public Rumput()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        
        snd1 = new GreenfootSound("slurp.wav");
        snd2 = new GreenfootSound("pop.wav");
        
        formatter = new java.text.SimpleDateFormat("hh:mm:ss");
        labelTime = new LabelTeks(formatter.format(new java.util.Date()));
        
        batu1 = new Batu();
        batu2 = new Batu();
        
        int wImgBatu = batu1.getImage().getWidth();
        int hImgBatu = batu1.getImage().getHeight();
        
        int midw = Math.round(getWidth()/2);
        int midh = Math.round(getHeight()/2);

        int x = Greenfoot.getRandomNumber(midw);
        int y = Greenfoot.getRandomNumber(midh);
        
        if (x - wImgBatu/2 < 0) x = wImgBatu;
        if (y - hImgBatu/2 < 0) y = hImgBatu;
        
        
        int x1 = midw + Greenfoot.getRandomNumber(midw);
        int y1 = midh + Greenfoot.getRandomNumber(midh);
        
        if (x1 + wImgBatu > getWidth()) x1 = getWidth() - wImgBatu;
        if (y1 + hImgBatu > getHeight()) y1 = getHeight() - hImgBatu;
        
        addObject(new Batu(), x, y);
        addObject(new Batu(), x1, y1);
        
        addObject(label, getWidth()/2, 20);
        addObject(labelTime, 100, 20);

        setPaintOrder(SeranggaKuning.class, SeranggaCoklat.class, SeranggaMerah.class, LabelTeks.class, Batu.class);
    }
    
    public GreenfootSound getSnd1() {
        return snd1;
    }

    public GreenfootSound getSnd2() {
        return snd2;
    }
    
    public void act() {
        java.util.List merah = getObjects(SeranggaMerah.class);
        if (merah.size() < MAX_SERANGGAMERAH) {
            if (Greenfoot.getRandomNumber(1000) > 990) {
                int x = Greenfoot.getRandomNumber(getWidth());
                int y = Greenfoot.getRandomNumber(getHeight());
                addObject(new SeranggaMerah(), x, y);
            }
        }
        
        labelTime.setTeks(formatter.format(new java.util.Date()));
        labelTime.cetakTeks();
        
        long elapsedTimeMillis = System.currentTimeMillis()-time;
        float elapsedTimeMin = elapsedTimeMillis/(60*1000F);
        if (skor < 0 || elapsedTimeMin > 2) {
            JOptionPane.showMessageDialog(null, "Game offer! Thank you.", "Info",  
                JOptionPane.INFORMATION_MESSAGE);
            Rumput.skor = 0;
            Rumput.label.setTeks("Score: " + Rumput.skor);
            Rumput.label.cetakTeks();
            Greenfoot.stop();
        }
    }
    
    public void started() {
        time = System.currentTimeMillis();
        Rumput.skor = 0;
        
        coklat = new SeranggaCoklat[5];
        kuning = new SeranggaKuning[4];
        
        coklat[0] = new SeranggaCoklat();
        coklat[1] = new SeranggaCoklat();
        coklat[2] = new SeranggaCoklat();
        coklat[3] = new SeranggaCoklat();
        coklat[4] = new SeranggaCoklat();
        
        kuning[0] = new SeranggaKuning();
        kuning[1] = new SeranggaKuning();
        kuning[2] = new SeranggaKuning();
        kuning[3] = new SeranggaKuning();
        
        for(int i=0; i < coklat.length; i++) {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(coklat[i], x, y);
        }
        
        for(int i=0; i < kuning.length; i++) {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject(kuning[i], x, y);
        }
    }
    
    public void stopped() {
        for(int i=0; i < coklat.length; i++) {
            removeObject(coklat[i]);
        }
        
        for(int i=0; i < kuning.length; i++) {
            removeObject(kuning[i]);
        }
        
        java.util.List merah = getObjects(SeranggaMerah.class);
        for(int i=0; i < merah.size(); i++) {
            removeObject( (SeranggaMerah)merah.get(i));
        }
    }
}
